/*
 * Copyright (C) 2013 Martin Sebastian Wain
 * http://acidotunismo.com
 *
 * Liberado bajo licencia CC-BY-3.0: http://creativecommons.org/licenses/by/3.0/
 * Podes hacer trabjos derivativos y usarlo comercialmente mientras me des el credito correspondiente.
 */

void setup() {
    Serial.begin(31250);
    Serial.println("DECODIFICADOR MIDI IN");
}

const char *cmd_names[8] = {
    " OFF", "  ON", "AFTR", " CHG", "PROG", "CHAF", "PTCH", "SYS"
};
const char *sys_names[16] = {
    "  EX", " F/4", "SPOS", "SSEL", "0xF4", "0xF5", "TUNE", " EOX", " CLK", "0xF9", "STRT", "CONT", "STOP", "0xFD", "ASEN", "RSET"
};

void loop() {
    if(Serial.available()) {
        byte type=Serial.read();
        byte cmd = type&0xf0;

        byte chan=type&0xf;
        byte p1,p2;
        if(cmd != 0xf0) { //Los mensajes de sistema no tienen canal
            Serial.print("CH-");
            Serial.print(chan, HEX);
        }
        Serial.print(' ');
        Serial.print(cmd_names[cmd>>4 & 0x7]);
        Serial.print(' ');
        switch(cmd) {
            //Estos tienen 2 parametros
            case 0x80:
            case 0x90:
            case 0xa0:
            case 0xb0:
            case 0xe0:
                while(Serial.available()<2);       //Esperamos hasta que haya 2 parametros q faltan
                p1 = Serial.read();
                p2 = Serial.read();
                Serial.print(p1, HEX);
                Serial.write(' ');
                Serial.print(p2, HEX);
                break;
            //Estos solo tienen un parametro
            case 0xc0:
            case 0xd0:
                while(!Serial.available());        //Esperamos al parametro que nos falta
                p1 = Serial.read();
                Serial.print(p1, HEX);
                break;
            //Hay que interpretar los mensajes de sistema de manera especial
            case 0xf0:
                Serial.print(sys_names[type&0xf]);
                Serial.print(' ');
                switch(type) {
                   //El mensaje SysEx se extiende hasta encontrar un "0xf7" (fin de mensaje)
                   case 0xf0:
                        while(Serial.available()) {
                            p1 = Serial.read();
                            Serial.print(p1, HEX);
                            Serial.print(' ');
                            if(p1 == 0xf7) break;
                        }
                        break;
                    case 0xf1:
                    case 0xf3:
                        while(!Serial.available());        //Esperamos al parametro que nos falta
                        p1 = Serial.read();
                        Serial.print(p1, HEX);
                        break;
                    case 0xf2:
                        while(Serial.available()<2);        //Esperamos hasta que haya 2 parametros q faltan
                        p1 = Serial.read();
                        p2 = Serial.read();
                        Serial.print(p1, HEX);
                        Serial.write(' ');
                        Serial.print(p2, HEX);
                        break;
                }
                break;
        }
        Serial.print("\n");
    }

}
